- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnHikEffector Class Reference

# OpenMayaAnim - API module for animation | FunctionSet classes

Search for all occurrences

## Detailed Description

Full Body IK end effector function set.

MFnHikEffector is the function set for full body ik effectors. An Full Body IK (FBIK/HIK) effector is a special transform that allows users to manipulate a Full Body IK system.

The methods of the parent class MFnTransform used to position the end effector.

`#include <MFnHikEffector.h>`

Inheritance diagram for MFnHikEffector:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnHikEffector ()
| Destructor.
| MFnHikEffector ()
| Default constructor.
| MFnHikEffector (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
| MFnHikEffector (const MDagPath &object, MStatus *ret=NULL)
| Constructor.
MObject | create (MObject parent=MObject::kNullObj, MStatus *ReturnStatus=NULL)
| Creates a new fbik effector.
MVector | getPivotOffset (MStatus *ReturnStatus=NULL) const
| Retrieve the pivot offset of this effector.
MStatus | setPivotOffset (const MVector &vector)
| Set the pivot offset for this effector.
MColor | getEffColor (MStatus *ReturnStatus=NULL) const
| Retrieve the cached humanIK color of this effector.
MStatus | setEffColor (const MColor &color)
| Set the humanIK color for this effector.
MStatus | getAuxiliaryEffectors (MObjectArray &effs) const
| Returns an array of the auxiliary effectors associated with this effector.
| MFnHikEffector (const MObject &object, MStatus *ret=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

~MFnHikEffector | ( |  | ) | `[virtual]`

Destructor.

Class destructor.

MFnHikEffector | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnHikEffector | ( | const MDagPath & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given constant MDagPath object.

Parameters:

  [in] | object | The const MDagPath to attach the function set to
  [out] | ReturnStatus | The return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnHikEffector | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kHikEffector.

Reimplemented from MFnTransform.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnHikEffector".

Reimplemented from MFnTransform.

MObject create | ( | MObject | parent = `MObject::kNullObj`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new fbik effector.

Parameters:

  [in] | parent | parent DAG node (usually none)
  [out] | ReturnStatus | return status

Returns:
  A handle to the new object

Status Codes:
  - MS::kSuccess operation successful
  - MS::kLicenseFailure application not licensed for attempted operation
  - MS::kFailure unexpected failure

Reimplemented from MFnTransform.

MVector getPivotOffset | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Retrieve the pivot offset of this effector.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Pivot offset vector.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure object error

MStatus setPivotOffset | ( | const MVector & | vector | ) |

Search for all occurrences

Set the pivot offset for this effector.

Parameters:

  [in] | vector | the new pivot offset

Returns:
  Status code

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure object error

MColor getEffColor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Retrieve the cached humanIK color of this effector.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Pivot offset vector.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure object error

MStatus setEffColor | ( | const MColor & | color | ) |

Search for all occurrences

Set the humanIK color for this effector.

Parameters:

  [in] | color | the new color

Returns:
  Status code

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure object error

MStatus getAuxiliaryEffectors | ( | MObjectArray & | effs | ) | const

Search for all occurrences

Returns an array of the auxiliary effectors associated with this effector.

Auxiliary effectors are used by humanIK to act as additional pivots.

Parameters:

  [out] | effs | the auxiliary effectors for this effector

Returns:
  Status code

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure object error

MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector
MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector MFnHikEffector